<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Wartung" (Maintenance)                               |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version: 4.1 / March 2015

*/

if (!defined('CPO')) exit;
$translator->addTranslation('maintenance', CPO_BASEDIR.$moduleDirectory.'/lang');

$GLOBALS['modules']['Maintenance'] = array(
    'directory' => $moduleDirectory,
    'caption'   => __('Maintenance'),
    'install'   => 'function: Maintenance_install',
    'activate'  => 'function: Maintenance_activate',
    'deactivate'=> 'function: Maintenance_deactivate',
    'uninstall' => 'function: Maintenance_uninstall',
    'manage'	=> 'function: Maintenance_manage',

	'page'			=> '',
	'varDEBUG'			=> '',
	'CPODEBUG'			=> '',
	'CPODEBUGQUERYCOUNT'			=> '',
	'state'			=> 'off'
	);

function Maintenance_install($moduleDirectory)
{
    $GLOBALS['message'][] = ___('The maintenance-module was successfully installed!');
}
function Maintenance_uninstall($moduleDirectory)
{
	$GLOBALS['message'][] = sprintf(__('Please remove the module directory %s to finally uninstall the maintenance-module.'),$moduleDirectory);
}
function Maintenance_activate()
{
    $GLOBALS['message'][] = ___('The maintenance-module got activated.');
}

function Maintenance_deactivate()
{
    $GLOBALS['message'][] = ___('The maintenance-module got deactivated.');
}

function Maintenance_manage()
{
	global $dbPrefix, $db, $k, $module_status, $newsletter_rubric_id;
	if(array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE)  {
		echo '<a href="'.BASE_ABS.$GLOBALS['modules']['Maintenance']['directory'].'/edit.php"><img src="'.SKIN_URL.'pic_settings.gif" title="'.__('settings').'" alt="'.__('settings').'"></a>';
        if ($activeModules['Maintenance']['page'] != '') {
            $preview_page = $activeModules['Maintenance']['page'];
        } else {
            $preview_page = BASE_ABS.'mod_maintenance/index.php';
        }
		echo '<a href="'.BASE_ABS.'mod_maintenance/index.php" target="preview"><img src="'.SKIN_URL.'pic_free.gif" title="'.__('preview').'" alt="'.__('preview').'"></a>';
	} else {
		echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic_" style="background: url('.SKIN_URL.'pic_settings.gif);" alt="'.  __('not available').'" title="'.__('not available').'">';
		echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic_" style="background: url('.SKIN_URL.'pic_free.gif);" alt="'.  __('not available').'" title="'.__('not available').'">';
	}
}

if(	array_key_exists('Maintenance', $activeModules)) {
	$varDEBUG = $activeModules['Maintenance']['varDEBUG'];
	if ($varDEBUG) $CPODEBUG = DEBUG_COUNT_QUERIES | DEBUG_LOG_QUERIES | DEBUG_RUNNING_TIME;
}

// figure out and set base_url
$auto_base_url = 'http://';
if(isset($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS'])=='on') {
    $auto_base_url='https://';
}

/* deprecated, creates problems with IE when using protected directories
if(isset($_SERVER['PHP_AUTH_USER'])) {
    $auto_base_url .= $_SERVER['PHP_AUTH_USER'];
    if(isset($_SERVER['PHP_AUTH_PW'])) {
        $auto_base_url .= ':'.$_SERVER['PHP_AUTH_PW'];
    }
    $auto_base_url .= '@';
}
*/

if(	array_key_exists('Maintenance', $activeModules) 
	&& empty($_SESSION['SID_user']['admin']) 
//	&& !defined('CPOBACKEND')
	&& $directory != '_admin'
	&& $activeModules['Maintenance']['state']=="on"
    && !defined('MAINTENANCE_PAGE')
    )  
{
    $mm_auto_base_url = 'http://';
    if(isset($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS'])=='on') {
        $mm_auto_base_url='https://';
    }
    $mm_auto_base_url .= $_SERVER['HTTP_HOST'];
    $DOCROOT = $_SERVER['DOCUMENT_ROOT'];
    if (empty($DOCROOT)) {
        $DOCROOT = substr(
            str_replace(array('\\', '//'), '/', $_SERVER['PATH_TRANSLATED']), 
            0, 
            -(strlen($_SERVER['SCRIPT_NAME']))
        );
    }

    $mm_auto_base_url .= substr(str_replace('\\', '/', __FILE__),  
                          strlen(str_replace('\\', '/', realpath($DOCROOT))), 
                          -strlen('mod_maintenance/2common-module.inc.php'));
    // echo $mm_auto_base_url;
    initVar($mm_base_url, $cpoSystem['base_url']);
    if (preg_match('=auto/?=i', $mm_base_url) || empty($mm_base_url)) {
        $mm_base_url = $mm_auto_base_url;
    }

    if (substr($mm_base_url, -1)!='/') $mm_base_url .= '/';
    preg_match('=^.*://[^/]*/(.*)$=', $mm_base_url, $mm_matches);
    define('MM_BASE_REL', '/'.$mm_matches[1]); // relative base url
    define('MM_BASE_ABS', $mm_base_url);       // absulute base url
    define('MM_BASE_URL', $mm_base_url);       // FIXME deprecate this

	if ($activeModules['Maintenance']['page'] != '') {
        header('Location:'.$activeModules['Maintenance']['page']);
    } else {
        //echo MM_BASE_ABS.'mod_maintenance/index.php';
        header('Location:'.MM_BASE_ABS.'mod_maintenance/index.php');
    }
    exit;
}
?>